#NoTrayIcon
#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icons\prog.ico
#AutoIt3Wrapper_outfile=Crown-Master.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=Crown-Master
#AutoIt3Wrapper_Res_Fileversion=1.2.1.7
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Array.au3>
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <Misc.au3>
#include <Sound.au3>
#include <WindowsConstants.au3>

If @DesktopWidth < 820 Or @DesktopHeight < 640 Then
	MsgBox(16, 'Crown-Master', 'FEHLER!' & @CR & 'Die Bildschirmauflsung reicht nicht aus!' & @CR & 'Es werden mindestens 820x640 Pixel bentigt.')
	Exit
EndIf

Opt('GUIOnEventMode', 1)

Global $sTitle = 'Crown-Master'
Global $sVersion = '1.2.1.7'
Global $sDate = '02.01.2011'
Global $sIconDir = @ScriptDir & '\icons\'
Global $sAppDir = @AppDataDir & '\Crown-Master\'
If Not FileExists($sAppDir) Then DirCreate($sAppDir)
Global $sInifile = $sAppDir & 'Crown-Master.ini'
If Not FileExists($sInifile) Then
	$hFile = FileOpen($sInifile, 2 + 8)
	If $hFile = -1 Then
		MsgBox(16, 'Crown-Master', 'FEHLER!' & @CR & 'Die Inidatei konnte nicht erstellt werden.')
		Exit
	EndIf
	FileClose($hFile)
EndIf
Global $ahGamePics[13], $ahScorePics[9], $ahBetPics[4], $ahHiPics[9], $ahJackPics[9], $ahWinPics[9]
Global $aLeft[6] = [40, 200, 360, 40, 200, 360], $aTop[6] = [226, 226, 226, 400, 400, 400]
Global $ahStop[6], $iStart = 0, $bStop = False, $iTime = 9, $bStart = False, $iWinnings = 0
Global $bNewGame = False, $bMultiply = False, $bNewHiScore = False, $aRoulette
Global $aWinFactor[10] = [0, 2, 5, 10, 20, 30, 40, 60, 80, 100]
Global $ahFactor[10], $aWinResult[6] = [12, 12, 12, 12, 12, 12]
Global $ahBetButton[2][4], $iScore = 1000, $iBet = 1, $iBetOld = 0
Global $sIniVersion = IniRead($sInifile, 'Check', 'Version', '0.0.0.0')
If $sIniVersion < $sVersion Then
	IniWrite($sInifile, 'Check', 'Version', $sVersion)
	IniWrite($sInifile, 'Config', 'HiScore', 100000)
	IniWrite($sInifile, 'Config', 'HiScoreName', $sTitle)
	IniWrite($sInifile, 'Config', 'HiScoreDate', $sDate)
	IniWrite($sInifile, 'Config', 'Jackpot', 2000)
EndIf
Global $iHiScore = IniRead($sInifile, 'Config', 'HiScore', 100000)
Global $sHiScoreName = IniRead($sInifile, 'Config', 'HiScoreName', $sTitle)
Global $sHiScoreDate = IniRead($sInifile, 'Config', 'HiScoreDate', $sDate)
Global $iJackpot = IniRead($sInifile, 'Config', 'Jackpot', 2000)
Global $hHelpGui, $hGraphic2, $hBitmap2, $hBackbuffer2
Global $sBlackList = FileRead($sAppDir & 'BlackList.txt')
_GDIPlus_Startup()
For $i = 0 To 12
	$ahGamePics[$i] = _GDIPlus_ImageLoadFromFile($sIconDir & 'item' & StringFormat('%02i', $i + 1) & '.png')
	If @error Then
		MsgBox(16, $sTitle, 'FEHLER!' & @CR & 'Die Items sind nicht vollstndig vorhanden.' & @CR & 'Das Spiel kann nicht gestartet werden.')
		_End()
	EndIf
Next
Global $sSoundDir = @ScriptDir & '\sounds\'
Global $aSoundname[8] = ['accept.au', 'explosion.au', 'lose.au', 'risk.au', 'start.au', 'stop.au', 'win0.wav', 'win1.au'], $aSound[UBound($aSoundname)]
Global $bSound = Execute(IniRead($sInifile, 'Config', 'Sound', True))
For $i = 0 To UBound($aSoundname) - 1
	$aSound[$i] = _SoundOpen($sSoundDir & $aSoundname[$i])
	If @error Then
		MsgBox(16, $sTitle, 'FEHLER!' & @CR & 'Die Sounds sind nicht vollstndig vorhanden.' & @CR & 'Das Spiel kann nicht gestartet werden.')
		_End()
	EndIf
Next

$hGui = GUICreate($sTitle & '   v' & StringLeft($sVersion, 3), 800, 600)
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUISetBkColor(0x000000)
GUISetIcon($sIconDir & 'prog.ico')
$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hGui)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics(800, 600, $hGraphic)
$hBackbuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

$hGameMenu = GUICtrlCreateMenu('Spiel')
GUICtrlCreateMenuItem('Schwarze Liste anzeigen', $hGameMenu)
GUICtrlSetOnEvent(-1, '_ShowBlackList')
If Not FileExists($sAppDir & 'BlackList.txt') Then GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateMenuItem('Neues Spiel beginnen', $hGameMenu)
GUICtrlSetOnEvent(-1, '_NewGameEvent')
GUICtrlCreateMenuItem('', $hGameMenu)
GUICtrlCreateMenuItem('Spiel beenden', $hGameMenu)
GUICtrlSetOnEvent(-1, '_End')
$hConfigMenu = GUICtrlCreateMenu('Einstellungen')
$hConfigSound = GUICtrlCreateMenuItem('Sounds benutzen', $hConfigMenu)
If $bSound Then GUICtrlSetState(-1, $GUI_CHECKED)
GUICtrlSetOnEvent(-1, '_SwitchSound')
$hHelpMenu = GUICtrlCreateMenu('?')
GUICtrlCreateMenuItem('Gewinnmglichkeiten', $hHelpMenu)
GUICtrlSetOnEvent(-1, '_WinningsHelp')
GUICtrlCreateMenuItem('Tastaturbelegung', $hHelpMenu)
GUICtrlSetOnEvent(-1, '_KeyHelp')
GUICtrlCreateMenuItem('Programm-Infos', $hHelpMenu)
GUICtrlSetOnEvent(-1, '_ProgInfo')

GUICtrlCreatePic($sIconDir & 'backgr.jpg', 0, 0, 800, 580)
GUICtrlSetState(-1, $GUI_DISABLE)

GUICtrlCreateLabel('Gesamtgewinn', 40, 13, 245, 20)
GUICtrlSetColor(-1, 0xDDDDAA)
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlCreateLabel('', 32, 35, 466, 76, Default, $WS_EX_CLIENTEDGE)
For $i = 0 To 8
	$ahScorePics[$i] = GUICtrlCreateIcon($sIconDir & '0.ico', 0, 40 + 50 * $i, 40, 46, 64)
Next

GUICtrlCreateLabel('Einsatz', 575, 13, 145, 20)
GUICtrlSetColor(-1, 0xDDDDAA)
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlCreateLabel('', 540, 50, 120, 45, Default, $WS_EX_CLIENTEDGE)
For $i = 0 To 3
	$ahBetPics[$i] = GUICtrlCreateIcon($sIconDir & '0.ico', 0, 550 + 25 * $i, 55, 23, 32)
	$ahBetButton[0][$i] = GUICtrlCreateButton('+', 553 + 25 * $i, 32, 18, 18)
	GUICtrlSetFont(-1, 10, 400, 0, 'Tahoma')
	GUICtrlSetOnEvent(-1, '_BetUp')
	$ahBetButton[1][$i] = GUICtrlCreateButton('-', 553 + 25 * $i, 95, 18, 18)
	GUICtrlSetFont(-1, 10, 400, 0, 'Tahoma')
	GUICtrlSetOnEvent(-1, '_BetDown')
Next
$hStart = GUICtrlCreateButton('START', 680, 52, 100, 40)
GUICtrlSetFont(-1, 16, 400, 0, 'Verdana')
GUICtrlSetOnEvent(-1, '_StartGame')

GUICtrlCreateLabel('HiScore', 20, 128, 145, 20)
GUICtrlSetColor(-1, 0xDDDDAA)
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlCreateLabel('', 10, 145, 245, 44, Default, $WS_EX_CLIENTEDGE)
$hHiScore = GUICtrlCreateLabel(StringFormat(' %s   %s', $sHiScoreDate, $sHiScoreName), 10, 188, 245, 20, Default, $WS_EX_CLIENTEDGE)
GUICtrlSetColor(-1, 0xDDDDAA)
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
For $i = 0 To 8
	$ahHiPics[$i] = GUICtrlCreateIcon($sIconDir & '0.ico', 0, 20 + 25 * $i, 150, 23, 32)
Next

GUICtrlCreateLabel('Jackpot', 284, 128, 145, 20)
GUICtrlSetColor(-1, 0xDDDDAA)
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlCreateLabel('', 276, 145, 245, 44, Default, $WS_EX_CLIENTEDGE)
For $i = 0 To 8
	$ahJackPics[$i] = GUICtrlCreateIcon($sIconDir & '0.ico', 0, 286 + 25 * $i, 150, 23, 32)
Next

GUICtrlCreateLabel('Gewinn', 548, 128, 145, 20)
GUICtrlSetColor(-1, 0xDDDDAA)
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlCreateLabel('', 540, 145, 245, 44, Default, $WS_EX_CLIENTEDGE)
For $i = 0 To 8
	$ahWinPics[$i] = GUICtrlCreateIcon($sIconDir & '0.ico', 0, 550 + 25 * $i, 150, 23, 32)
Next

For $i = 0 To 9
	If $i = 0 Then
		$ahFactor[0] = GUICtrlCreateLabel('         ' & $aWinFactor[$i], 540, 500 - $i * 31, 245, 32, Default, $WS_EX_STATICEDGE)
	Else
		$ahFactor[$i] = GUICtrlCreateLabel('      x ' & $aWinFactor[$i], 540, 500 - $i * 31, 245, 32, Default, $WS_EX_STATICEDGE)
	EndIf
	GUICtrlSetColor(-1, 0x000000)
	GUICtrlSetBkColor(-1, 0x444444)
	GUICtrlSetFont(-1, 18, 800, 0, 'Verdana')
Next
$hRisk = GUICtrlCreateButton('Risiko', 540, 540, 100, 28)
GUICtrlSetFont(-1, 12, 400, 0, 'Verdana')
GUICtrlSetState(-1, $GUI_HIDE)
$hNoRisk = GUICtrlCreateButton('bernehmen', 647, 540, 140, 28)
GUICtrlSetFont(-1, 12, 400, 0, 'Verdana')
GUICtrlSetState(-1, $GUI_HIDE)

_SetBet($ahBetPics, 'g', $iBet)
_SetHiScore($ahScorePics, 'y', $iScore)
_SetHiScore($ahHiPics, 'o', $iHiScore)
_SetHiScore($ahJackPics, 'o', $iJackpot)
_SetHiScore($ahWinPics, 'g', $iWinnings)

GUISetState()

Global $aAccKeys[15][2]
For $i = 0 To 5
	GUICtrlCreateLabel('', $aLeft[$i] - 4, $aTop[$i] - 4, 136, 136, Default, $WS_EX_CLIENTEDGE)
	$ahStop[$i] = GUICtrlCreateButton('[' & $i + 1 & '] STOP in ' & $iTime & ' sek.', $aLeft[$i] - 4, $aTop[$i] + 132, 136, 28)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	GUICtrlSetState(-1, $GUI_HIDE)
	$aAccKeys[$i][0] = $i + 1
	$aAccKeys[$i][1] = $ahStop[$i]
	_GDIPlus_GraphicsDrawImageRect($hBackbuffer, $ahGamePics[12], $aLeft[$i], $aTop[$i], 128, 128)
	_GDIPlus_GraphicsDrawImage($hGraphic, $hBitmap, 0, 0)
Next
$aAccKeys[6][0] = 's'
$aAccKeys[6][1] = $hStart
$aAccKeys[7][0] = 'r'
$aAccKeys[7][1] = $hRisk
$aAccKeys[8][0] = 'u'
$aAccKeys[8][1] = $hNoRisk
$aAccKeys[9][0] = '{+}'
$aAccKeys[9][1] = $ahBetButton[0][3]
$aAccKeys[10][0] = '-'
$aAccKeys[10][1] = $ahBetButton[1][3]
$aAccKeys[11][0] = '{UP}'
$aAccKeys[11][1] = $ahBetButton[0][2]
$aAccKeys[12][0] = '{DOWN}'
$aAccKeys[12][1] = $ahBetButton[1][2]
$aAccKeys[13][0] = '{PGUP}'
$aAccKeys[13][1] = $ahBetButton[0][1]
$aAccKeys[14][0] = '{PGDN}'
$aAccKeys[14][1] = $ahBetButton[1][1]
GUISetAccelerators($aAccKeys)
GUIRegisterMsg($WM_PAINT, '_RefreshIcons')

While Sleep(20)
	If $bStart Then
		If $bSound Then _SoundPlay($aSound[4], 1)
		$bNewGame = False
		$bStart = False
		GUICtrlSetState($ahStop[$iStart], $GUI_SHOW)
		GUICtrlSetOnEvent($ahStop[$iStart], '_StopItem')
		AdlibRegister('_TimeStopItem', 1000)
        While Not $bStop
            For $i = 0 To 5
                If $bStop Then ExitLoop 2
                If $i >= $iStart Then $aWinResult[$i] = Random(0, 11, 1)
                _GDIPlus_GraphicsDrawImageRect($hBackbuffer, $ahGamePics[12], $aLeft[$i], $aTop[$i], 128, 128)
                _GDIPlus_GraphicsDrawImageRect($hBackbuffer, $ahGamePics[$aWinResult[$i]], $aLeft[$i], $aTop[$i], 128, 128)
                _GDIPlus_GraphicsDrawImage($hGraphic, $hBitmap, 0, 0)
            Next
            Sleep(300)
        WEnd
		If $bNewGame Then ContinueLoop
		$iWinnings = _FindWinnings($aWinResult)
		Select
			Case $iWinnings < 0
				$iJackpot += Int($iBet / 2)
				_SetHiScore($ahJackPics, 'o', $iJackpot)
				IniWrite($sInifile, 'Config', 'Jackpot', $iJackpot)
				$iScore += $iWinnings
				_SetHiScore($ahScorePics, 'y', $iScore)
			Case $iWinnings = 0
				If $bSound Then _SoundPlay($aSound[6], 1)
				_SetHiScore($ahWinPics, 'g', $iWinnings)
				$iJackpot += Int($iBet / 2)
				_SetHiScore($ahJackPics, 'o', $iJackpot)
				IniWrite($sInifile, 'Config', 'Jackpot', $iJackpot)
				_SetStateBetButtons($GUI_ENABLE)
				GUICtrlSetState($hStart, $GUI_SHOW)
				GUICtrlSetOnEvent($hStart, '_StartGame')
			Case $iWinnings > 0
				If $bSound Then _SoundPlay($aSound[7])
				_SetHiScore($ahWinPics, 'g', $iWinnings)
				If UBound($aRoulette) > 0 Then
					GUICtrlSetState($hRisk, $GUI_SHOW)
					GUICtrlSetOnEvent($hRisk, '_MultiplyFactor')
				EndIf
				GUICtrlSetState($hNoRisk, $GUI_SHOW)
				GUICtrlSetOnEvent($hNoRisk, '_AcceptWinnings')
		EndSelect
		If $iScore + $iWinnings > 999999999 Then
			_BankRobbery()
			_NewGame()
		EndIf
		If $iScore + $iWinnings <= 0 Then _GameOver()
	EndIf
	If $bMultiply Then _MultiplyFactorFunc()
WEnd

Func _RefreshIcons($hWnd, $Msg, $wParam, $lParam)
	Switch $hWnd
		Case $hGui
			_GDIPlus_GraphicsDrawImage($hGraphic, $hBitmap, 0, 0)
		Case $hHelpGui
			_GDIPlus_GraphicsDrawImage($hGraphic2, $hBitmap2, 0, 0)
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_RefreshIcons

Func _SwitchSound()
	$bSound = Not $bSound
	IniWrite($sInifile, 'Config', 'Sound', $bSound)
	If $bSound Then
		GUICtrlSetState($hConfigSound, $GUI_CHECKED)
	Else
		GUICtrlSetState($hConfigSound, $GUI_UNCHECKED)
	EndIf
EndFunc   ;==>_SwitchSound

Func _BankRobbery()
	Local $sSound = _SoundOpen($sSoundDir & 'police.mp3'), $hPoliceGui, $sMsg, $hName, $hAccept, $hBlackList, $aItems, $hFile
	If $bSound Then _SoundPlay($sSound)
	$iScore = 999999999
	_SetHiScore($ahScorePics, 'y', $iScore)
	Opt('GUIOnEventMode', 0)
	$hPoliceGui = GUICreate($sTitle & '   -   Polizeirevier', 640, 500, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION), Default, $hGui)
	GUISetIcon($sIconDir & 'prog.ico')
	GUISetBkColor(0x81A7B3)
	GUICtrlCreateIcon($sIconDir & 'bennet.ico', 0, 480, 10, 128, 128)
	$sMsg = 'Ihnen wird vorgeworfen, Sie htten den Spielautomaten manipuliert, um an diesen Gewinn zu kommen.\n\n'
	$sMsg &= 'Somit wird Ihnen der Gewinn abgenommen, dem Casino zurckgegeben und Sie kommen auf die " schwarze"  Liste.\n\n'
	$sMsg &= 'Unsere Ermittlungen haben Sie folgendermaen identifiziert. Wenn das nicht ihr richtiger Name ist, dann tragen '
	$sMsg &= 'Sie hier Ihren richtigen Namen ein und klicken dann auf [Ok].'
	GUICtrlCreateLabel(StringFormat($sMsg), 30, 20, 470, 180)
	GUICtrlSetFont(-1, 14, 400, 2, 'Times New Roman')
	$hName = GUICtrlCreateInput(@UserName, 30, 220, 300, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	$hAccept = GUICtrlCreateButton('Ok', 340, 218, 70, 30)
	GUICtrlSetFont(-1, 12, 400, 0, 'Arial')
	GUICtrlCreateIcon($sIconDir & 'handcuffs.ico', 0, 480, 150, 128, 128)
	GUICtrlCreateIcon($sIconDir & 'police.ico', 0, 0, 260, 256, 256)
	GUICtrlCreateLabel('Liste der Automatenknacker:', 280, 265, 300, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	$hBlackList = GUICtrlCreateListView('Datum|Name', 270, 290, 350, 200)
	$aItems = StringSplit($sBlackList, @CRLF, 1)
	For $i = 1 To $aItems[0] - 1
		GUICtrlCreateListViewItem($aItems[$i], $hBlackList)
	Next
	_GUICtrlListView_SetColumnWidth($hBlackList, 0, $LVSCW_AUTOSIZE)
	GUISetState(@SW_SHOW, $hPoliceGui)
	Do
		$sMsg = GUIGetMsg()
		If $sMsg = $hAccept Then
			GUICtrlSetState($hName, $GUI_DISABLE)
			GUICtrlSetState($hAccept, $GUI_DISABLE)
			$sBlackList = @MDAY & '.' & @MON & '.' & @YEAR & '|' & GUICtrlRead($hName) & @CRLF & $sBlackList
			$hFile = FileOpen($sAppDir & 'BlackList.txt', 2)
			If $hFile <> -1 Then
				FileWrite($hFile, $sBlackList)
				FileClose($hFile)
			EndIf
			_GUICtrlListView_DeleteAllItems($hBlackList)
			$aItems = StringSplit($sBlackList, @CRLF, 1)
			For $i = 1 To $aItems[0] - 1
				GUICtrlCreateListViewItem($aItems[$i], $hBlackList)
			Next
			_GUICtrlListView_SetColumnWidth($hBlackList, 0, $LVSCW_AUTOSIZE)
		EndIf
	Until $sMsg = -3
	GUIDelete($hPoliceGui)
	Opt('GUIOnEventMode', 1)
	_SoundClose($sSound)
	IniWrite($sInifile, 'Config', 'HiScore', 100000)
	IniWrite($sInifile, 'Config', 'HiScoreName', $sTitle)
	IniWrite($sInifile, 'Config', 'HiScoreDate', $sDate)
	IniWrite($sInifile, 'Config', 'Jackpot', 2000)
	$iHiScore = 100000
	$sHiScoreName = $sTitle
	$sHiScoreDate = $sDate
	$iJackpot = 2000
EndFunc   ;==>_BankRobbery

Func _ShowBlackList()
	Local $hPoliceGui, $hBlackList, $aItems
	Opt('GUIOnEventMode', 0)
	$hPoliceGui = GUICreate($sTitle & '   -   Schwarze Liste', 640, 250, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION), Default, $hGui)
	GUISetIcon($sIconDir & 'prog.ico')
	GUISetBkColor(0x81A7B3)
	GUICtrlCreateIcon($sIconDir & 'police.ico', 0, 0, 10, 256, 256)
	GUICtrlCreateLabel('Liste der Automatenknacker:', 280, 10, 300, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	$hBlackList = GUICtrlCreateListView('Datum|Name', 270, 40, 350, 200)
	$aItems = StringSplit($sBlackList, @CRLF, 1)
	For $i = 1 To $aItems[0] - 1
		GUICtrlCreateListViewItem($aItems[$i], $hBlackList)
	Next
	_GUICtrlListView_SetColumnWidth($hBlackList, 0, $LVSCW_AUTOSIZE)
	GUISetState(@SW_SHOW, $hPoliceGui)
	Do
	Until GUIGetMsg() = -3
	GUIDelete($hPoliceGui)
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_ShowBlackList

Func _GameOver()
	If $bSound Then _SoundPlay($aSound[1])
	If MsgBox(4, $sTitle, 'Spielende! Kein Geld mehr vorhanden.' & @CR & 'Neues Spiel starten?', 0, $hGui) = 7 Then _End()
	_NewGame()
EndFunc   ;==>_GameOver

Func _NewGameEvent()
	If MsgBox(4, $sTitle, 'Wirklich ein neues Spiel starten?', 0, $hGui) = 7 Then Return
	_NewGame()
EndFunc   ;==>_NewGameEvent

Func _NewGame()
	AdlibUnRegister('_TimeStopItem')
	$bMultiply = False
	$bStart = False
	$bStop = True
	$bNewGame = True
	$bNewHiScore = False
	$iStart = 0
	Global $aWinResult[6] = [12, 12, 12, 12, 12, 12]
	For $i = 0 To 5
		GUICtrlSetState($ahStop[$i], $GUI_HIDE)
		GUICtrlSetOnEvent($ahStop[$i], '')
		_GDIPlus_GraphicsDrawImageRect($hGraphic, $ahGamePics[12], $aLeft[$i], $aTop[$i], 128, 128)
	Next
	GUICtrlSetState($hRisk, $GUI_HIDE)
	GUICtrlSetOnEvent($hRisk, '')
	GUICtrlSetState($hNoRisk, $GUI_HIDE)
	GUICtrlSetOnEvent($hNoRisk, '')
	_SetStateBetButtons($GUI_ENABLE)
	GUICtrlSetState($hStart, $GUI_SHOW)
	GUICtrlSetOnEvent($hStart, '_StartGame')
	_SetHiScore($ahHiPics, 'o', $iHiScore)
	$iScore = 1000
	_SetHiScore($ahScorePics, 'y', $iScore)
	$iBet = '0001'
	_SetBet($ahBetPics, 'g', Number($iBet))
EndFunc   ;==>_NewGame

Func _FindWinnings(ByRef $aResult)
	Local $aJoker, $aTmp, $iRet = 0
	$aTmp = _ArrayFindAll($aResult, 2) ; Find Bombs
	If UBound($aTmp) > 2 Then Return -$iScore
	If UBound($aTmp) > 0 Then Return 0
	$aRoulette = _ArrayFindAll($aResult, 3) ; Find Roulette
	$aJoker = _ArrayFindAll($aResult, 6) ; Find Joker
	If UBound($aJoker) > 2 Then
		$iRet = $iJackpot + Number($iBet) * 10 * UBound($aJoker)
		$iJackpot = 0
		_SetHiScore($ahJackPics, 'o', $iJackpot)
		Return $iRet
	EndIf
	$aTmp = _ArrayFindAll($aResult, 10) ; Find Hats
	If UBound($aTmp) > 2 Or UBound($aTmp) + UBound($aJoker) > 2 Then
		$iRet = $iJackpot + Number($iBet)
		$iJackpot = 0
		_SetHiScore($ahJackPics, 'o', $iJackpot)
		Return $iRet
	EndIf
	For $i = 0 To 11
		If $i = 2 Or $i = 6 Then ContinueLoop
		$aTmp = _ArrayFindAll($aResult, $i) ; Find Rest
		If UBound($aTmp) > 2 Or (UBound($aTmp) + UBound($aJoker)) > 2 Then
			If (UBound($aTmp) + UBound($aJoker)) * Number($iBet) > $iRet Then $iRet = (UBound($aTmp) + UBound($aJoker)) * Number($iBet)
		EndIf
	Next
	Return $iRet
EndFunc   ;==>_FindWinnings

Func _StartGame()
	GUICtrlSetState($hStart, $GUI_HIDE)
	GUICtrlSetOnEvent($hStart, '')
	_SetStateBetButtons($GUI_DISABLE)
	If $iBet > $iScore Then
		$iBet = $iScore
		_SetBet($ahBetPics, 'g', $iBet)
	EndIf
	$iScore -= $iBet
	_SetHiScore($ahScorePics, 'y', $iScore)
	$bStart = True
	$bStop = False
EndFunc   ;==>_StartGame

Func _SetStateBetButtons($sState)
	For $i = 0 To 5
		_GDIPlus_GraphicsDrawImageRect($hBackbuffer, $ahGamePics[12], $aLeft[$i], $aTop[$i], 128, 128)
	Next
	For $i = 0 To 3
		GUICtrlSetState($ahBetButton[0][$i], $sState)
		If $sState = $GUI_DISABLE Then
			GUICtrlSetOnEvent($ahBetButton[0][$i], '')
		Else
			GUICtrlSetOnEvent($ahBetButton[0][$i], '_BetUp')
		EndIf
		GUICtrlSetState($ahBetButton[1][$i], $sState)
		If $sState = $GUI_DISABLE Then
			GUICtrlSetOnEvent($ahBetButton[1][$i], '')
		Else
			GUICtrlSetOnEvent($ahBetButton[1][$i], '_BetDown')
		EndIf
	Next
EndFunc   ;==>_SetStateBetButtons

Func _MultiplyFactor()
	$bMultiply = True
EndFunc   ;==>_MultiplyFactor

Func _MultiplyFactorFunc()
	GUICtrlSetState($hRisk, $GUI_HIDE)
	GUICtrlSetOnEvent($hRisk, '')
	Local $iFactor = 1, $iOut = 0, $iTimer1, $iSleep = 200
	For $j = 0 To 9
		GUICtrlSetBkColor($ahFactor[$j], 0x66FF88)
		Sleep(40)
	Next
	For $j = 9 To 0 Step -1
		Sleep(40)
		GUICtrlSetBkColor($ahFactor[$j], 0x444444)
	Next
	Do
		Do
			GUICtrlSetBkColor($ahFactor[$iFactor - 1], 0xFFFF88)
			GUICtrlSetBkColor($ahFactor[0], 0x66FF88)
			$iOut = 0
			$iTimer1 = TimerInit()
			Do
				Sleep(10)
				If _IsPressed('20') Then
					If $bSound Then _SoundPlay($aSound[2])
					ExitLoop 2
				EndIf
			Until TimerDiff($iTimer1) > $iSleep - 10 * $iFactor
			GUICtrlSetBkColor($ahFactor[0], 0x444444)
			GUICtrlSetBkColor($ahFactor[$iFactor], 0x66FF88)
			$iOut = $iFactor
			$iTimer1 = TimerInit()
			Do
				Sleep(10)
				If _IsPressed('20') Then
					If $bSound Then _SoundPlay($aSound[3])
					ExitLoop 2
				EndIf
			Until TimerDiff($iTimer1) > $iSleep - 10 * $iFactor
			GUICtrlSetBkColor($ahFactor[$iFactor], 0x444444)
			If Not $bMultiply Then
				$iFactor -= 1
				ExitLoop 2
			EndIf
		Until _IsPressed('20')
		GUICtrlSetBkColor($ahFactor[$iFactor], 0xFFFF88)
		$iFactor += 1
		Sleep(300)
	Until $iOut = 0 Or $iFactor > 9
	If $iFactor > 9 Then $iFactor = 9
	If $iOut = 0 Then
		GUICtrlSetState($hNoRisk, $GUI_HIDE)
		GUICtrlSetOnEvent($hNoRisk, '')
		For $i = $iFactor To 0 Step -1
			GUICtrlSetBkColor($ahFactor[$i], 0x444444)
			Sleep(50)
		Next
		$iJackpot += Int($iBet / 2)
		If $iJackpot < 2000 Then
			$iJackpot = 2000
			IniWrite($sInifile, 'Config', 'Jackpot', $iJackpot)
		EndIf
		_SetHiScore($ahJackPics, 'o', $iJackpot)
		IniWrite($sInifile, 'Config', 'Jackpot', $iJackpot)
		$iWinnings = 0
		_SetHiScore($ahWinPics, 'g', $iWinnings)
		If $iScore <= 0 Then Return _GameOver()
	Else
		If $bSound Then _SoundPlay($aSound[0])
		For $j = 0 To 9
			GUICtrlSetBkColor($ahFactor[$j], 0x66FF88)
			Sleep(40)
		Next
		For $j = 0 To 9
			Sleep(40)
			GUICtrlSetBkColor($ahFactor[$j], 0x444444)
		Next
		If $iFactor > 0 Then
			$iWinnings *= $aWinFactor[$iFactor]
			_SetHiScore($ahWinPics, 'g', $iWinnings)
			Sleep(1000)
		EndIf
		$iScore += $iWinnings
		_SetHiScore($ahScorePics, 'y', $iScore)
		_CheckHiScore()
		$iWinnings = 0
		_SetHiScore($ahWinPics, 'g', $iWinnings)
	EndIf
	$bMultiply = False
	GUICtrlSetState($hNoRisk, $GUI_HIDE)
	GUICtrlSetOnEvent($hNoRisk, '')
	_SetStateBetButtons($GUI_ENABLE)
	GUICtrlSetState($hStart, $GUI_SHOW)
	GUICtrlSetOnEvent($hStart, '_StartGame')
EndFunc   ;==>_MultiplyFactorFunc

Func _AcceptWinnings()
	If $bSound Then _SoundPlay($aSound[0])
	GUICtrlSetState($hRisk, $GUI_HIDE)
	GUICtrlSetOnEvent($hRisk, '')
	GUICtrlSetState($hNoRisk, $GUI_HIDE)
	GUICtrlSetOnEvent($hNoRisk, '')
	If $bMultiply Then
		$bMultiply = False
		Return
	EndIf
	$iScore += $iWinnings
	_SetHiScore($ahScorePics, 'y', $iScore)
	_CheckHiScore()
	$iWinnings = 0
	_SetHiScore($ahWinPics, 'g', $iWinnings)
	_SetStateBetButtons($GUI_ENABLE)
	GUICtrlSetState($hStart, $GUI_SHOW)
	GUICtrlSetOnEvent($hStart, '_StartGame')
EndFunc   ;==>_AcceptWinnings

Func _CheckHiScore()
	If $iScore > $iHiScore Then
		If Not $bNewHiScore Then
			$bNewHiScore = True
			GUISetAccelerators('')
			$sHiScoreName = InputBox($sTitle, 'Neuer Rekord! Bitte gib Deinen Namen ein.', @UserName, '', 250, 160, Default, Default, 0, $hGui)
			GUISetAccelerators($aAccKeys)
			IniWrite($sInifile, 'Config', 'HiScoreName', $sHiScoreName)
		EndIf
		$sHiScoreDate = @MDAY & '.' & @MON & '.' & @YEAR
		IniWrite($sInifile, 'Config', 'HiScoreDate', $sHiScoreDate)
		GUICtrlSetData($hHiScore, StringFormat(' %s   %s', $sHiScoreDate, $sHiScoreName))
		$iHiScore = $iScore
		_SetHiScore($ahHiPics, 'y', $iHiScore)
		IniWrite($sInifile, 'Config', 'HiScore', $iHiScore)
	EndIf
	If $iScore > 999999999 Then
		_BankRobbery()
		_NewGame()
	EndIf
	If $iJackpot < 2000 Then
		$iJackpot = 2000
		_SetHiScore($ahJackPics, 'o', $iJackpot)
		IniWrite($sInifile, 'Config', 'Jackpot', $iJackpot)
	EndIf
EndFunc   ;==>_CheckHiScore

Func _BetUp()
	Local $iCount = (@GUI_CtrlId - $ahBetButton[0][0]) / 3
	$iBet += 10 ^ (3 - $iCount)
	If $iBet > $iScore Then $iBet = $iScore
	If $iBet > 9999 Then $iBet = 9999
	_SetBet($ahBetPics, 'g', $iBet)
EndFunc   ;==>_BetUp

Func _BetDown()
	Local $iCount = (@GUI_CtrlId - $ahBetButton[1][0]) / 3
	$iBet -= 10 ^ (3 - $iCount)
	If $iBet < 1 Then $iBet = 1
	_SetBet($ahBetPics, 'g', $iBet)
EndFunc   ;==>_BetDown

Func _SetBet(ByRef $aPics, $sColor, $iScore)
	Local $iLen = StringLen($iScore), $bChange = False
	$iScore = StringRight('0000' & $iScore, 4)
	For $i = 0 To 3
		If $bChange Or StringMid($iScore, $i + 1, 1) <> StringMid($iBetOld, $i + 1, 1) Then
			$bChange = True
			If $i < (4 - $iLen) Then
				GUICtrlSetImage($aPics[$i], $sIconDir & '0.ico')
			Else
				GUICtrlSetImage($aPics[$i], $sIconDir & $sColor & StringMid($iScore, $i + 1, 1) & '.ico')
			EndIf
		EndIf
	Next
	$iBetOld = $iScore
EndFunc   ;==>_SetBet

Func _SetHiScore(ByRef $aPics, $sColor, $iScore)
	Local $iLen = StringLen($iScore)
	$iScore = StringRight('000000000' & $iScore, 9)
	For $i = 0 To 8
		If $i < (9 - $iLen) Then
			GUICtrlSetImage($aPics[$i], $sIconDir & '0.ico')
		Else
			GUICtrlSetImage($aPics[$i], $sIconDir & $sColor & StringMid($iScore, $i + 1, 1) & '.ico')
		EndIf
	Next
EndFunc   ;==>_SetHiScore

Func _TimeStopItem()
	$iTime -= 1
	If $iTime = 0 Then _StopItem()
	GUICtrlSetData($ahStop[$iStart], '[' & $iStart + 1 & '] STOP in ' & $iTime & ' sek.')
EndFunc   ;==>_TimeStopItem

Func _StopItem()
	AdlibUnRegister('_TimeStopItem')
	GUICtrlSetState($ahStop[$iStart], $GUI_HIDE)
	GUICtrlSetOnEvent($ahStop[$iStart], '')
	If $bSound Then
		_SoundStop($aSound[5])
		_SoundPlay($aSound[5])
	EndIf
	$iStart += 1
	$iTime = 9
	If $iStart = 6 Then
		$iStart = 0
		$bStop = True
		Return
	EndIf
	AdlibRegister('_TimeStopItem', 1000)
	GUICtrlSetState($ahStop[$iStart], $GUI_SHOW)
	GUICtrlSetOnEvent($ahStop[$iStart], '_StopItem')
EndFunc   ;==>_StopItem

Func _End()
	For $i = 0 To UBound($aSoundname) - 1
		$aSound[$i] = _SoundClose($aSound[$i])
	Next
	For $i = 0 To 12
		_GDIPlus_ImageDispose($ahGamePics[$i])
	Next
	_GDIPlus_GraphicsDispose($hBackbuffer)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>_End

Func _WinningsHelp()
	Global $hHelpGui, $hGraphic2, $hBitmap2, $hBackbuffer2
	Opt('GUIOnEventMode', 0)
	$hHelpGui = GUICreate($sTitle & '   -   Gewinnmglichkeiten', 640, 590, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION), Default, $hGui)
	GUISetIcon($sIconDir & 'prog.ico')
	GUISetBkColor(0xFFDB9D, $hHelpGui)
	$hGraphic2 = _GDIPlus_GraphicsCreateFromHWND($hHelpGui)
	$hBitmap2 = _GDIPlus_BitmapCreateFromGraphics(640, 590, $hGraphic2)
	$hBackbuffer2 = _GDIPlus_ImageGetGraphicsContext($hBitmap2)
	For $i = 0 To 2
		_GDIPlus_GraphicsDrawImageRect($hBackbuffer2, $ahGamePics[6], 10 + $i * 70, 10, 64, 64)
		_GDIPlus_GraphicsDrawImageRect($hBackbuffer2, $ahGamePics[10], 10 + $i * 70, 90, 64, 64)
		If $i = 0 Then _GDIPlus_GraphicsDrawImageRect($hBackbuffer2, $ahGamePics[2], 10 + $i * 70, 170, 64, 64)
		_GDIPlus_GraphicsDrawImageRect($hBackbuffer2, $ahGamePics[2], 10 + $i * 70, 250, 64, 64)
		_GDIPlus_GraphicsDrawImageRect($hBackbuffer2, $ahGamePics[4], 10 + $i * 70, 330, 64, 64)
	Next
	GUICtrlCreateLabel('Drei oder mehr Kronen' & @CR & ' = Jackpot + Einsatz x 10 x Anzahl der Kronen', 230, 20, 400, 50)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateLabel('Drei oder mehr Hte' & @CR & ' = Jackpot + Einsatz', 230, 100, 400, 50)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateLabel('Eine oder zwei Bomben' & @CR & ' = Man verliert den Einsatz', 230, 180, 400, 50)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateLabel('Drei oder mehr Bomben' & @CR & ' = Der Gesamtgewinn ist weg (Spiel zu Ende)', 230, 260, 400, 50)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateLabel('Drei oder mehr der brigen Symbole' & @CR & ' = Einsatz x Anzahl der Symbole', 230, 340, 400, 50)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	_GDIPlus_GraphicsDrawImageRect($hBackbuffer2, $ahGamePics[6], 10, 420, 64, 64)
	GUICtrlCreateLabel('Die Kronen dienen auch als Joker. Sie knnen also auch mit Hten oder den brigen Symbolen kombiniert werden. Allerdings werden sie nicht als Bomben gewertet!', 90, 430, 540, 80)
	GUICtrlSetFont(-1, 14, 400, 2, 'Times New Roman')
	_GDIPlus_GraphicsDrawImageRect($hBackbuffer2, $ahGamePics[3], 10, 500, 64, 64)
	GUICtrlCreateLabel('Hat man einen Gewinn erzielt und mindestens ein Roulette-Symbol erhalten, so besteht die Mglichkeit diesen Gewinn auf der Risiko-Leiter zu vervielfachen oder ihn wieder zu verlieren.', 90, 510, 540, 80)
	GUICtrlSetFont(-1, 14, 400, 2, 'Times New Roman')
	GUISetState(@SW_SHOW, $hHelpGui)
	GUIRegisterMsg($WM_PAINT, '_RefreshIcons')
	Do
	Until GUIGetMsg() = -3
	_GDIPlus_GraphicsDispose($hBackbuffer2)
	_GDIPlus_BitmapDispose($hBitmap2)
	_GDIPlus_GraphicsDispose($hGraphic2)
	GUIDelete($hHelpGui)
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_WinningsHelp

Func _KeyHelp()
	Local $hKeyGui
	Opt('GUIOnEventMode', 0)
	$hKeyGui = GUICreate($sTitle & '   -   Tastaturbelegung', 420, 460, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION), Default, $hGui)
	GUISetIcon($sIconDir & 'prog.ico')
	GUISetBkColor(0xFFDB9D, $hKeyGui)
	GUICtrlCreateLabel('Tasten fr das Spiel:', 10, 5, 400, 35)
	GUICtrlSetFont(-1, 24, 400, 6, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_s.ico', 0, 10, 50, 32, 32)
	GUICtrlCreateLabel('zum starten der Symbole', 140, 55, 400, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_1.ico', 0, 10, 90, 32, 32)
	GUICtrlCreateLabel('. . .', 50, 95, 100, 25)
	GUICtrlSetFont(-1, 20, 800, 0, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_6.ico', 0, 90, 90, 32, 32)
	GUICtrlCreateLabel('zum stoppen der Symbole', 140, 95, 400, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_u.ico', 0, 10, 130, 32, 32)
	GUICtrlCreateLabel('zum bernehmen des Gewinns', 140, 135, 400, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_r.ico', 0, 10, 170, 32, 32)
	GUICtrlCreateLabel('fr die Risikotaste', 140, 175, 400, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_space.ico', 0, 10, 210, 64, 32)
	GUICtrlCreateLabel('fr die Risikoleiter', 140, 215, 400, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateLabel('Einsatz verndern:', 10, 270, 400, 35)
	GUICtrlSetFont(-1, 24, 400, 6, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_plus.ico', 0, 10, 315, 32, 32)
	GUICtrlCreateLabel('  &&  ', 47, 320, 100, 25)
	GUICtrlSetFont(-1, 16, 600, 0, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_minus.ico', 0, 90, 315, 32, 32)
	GUICtrlCreateLabel('fr die Einerstelle', 140, 320, 400, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_up.ico', 0, 10, 355, 32, 32)
	GUICtrlCreateLabel('  &&  ', 47, 360, 100, 25)
	GUICtrlSetFont(-1, 16, 600, 0, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_down.ico', 0, 90, 355, 32, 32)
	GUICtrlCreateLabel('fr die Zehnerstelle', 140, 360, 400, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_pgup.ico', 0, 10, 395, 32, 32)
	GUICtrlCreateLabel('  &&  ', 47, 400, 100, 25)
	GUICtrlSetFont(-1, 16, 600, 0, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'key_pgdown.ico', 0, 90, 395, 32, 32)
	GUICtrlCreateLabel('fr die Hunderterstelle', 140, 400, 400, 25)
	GUICtrlSetFont(-1, 16, 400, 2, 'Times New Roman')
	GUISetState(@SW_SHOW, $hKeyGui)
	Do
	Until GUIGetMsg() = -3
	GUIDelete($hKeyGui)
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_KeyHelp

Func _ProgInfo()
	Local $sMsg = 'Version:\t%s\nDatum:\t%s\nAutor:\tOscar (www.autoit.de)\nEMail:\tOscar@elektronik-kurs.de\n\n'
	$sMsg &= 'Rechtliches:\n'
	$sMsg &= '- Dieses Programm darf, zeitlich unbegrenzt, kostenlos genutzt werden!\n'
	$sMsg &= '- Eine evtl. Weitergabe muss kostenlos, vollstndig und unverndert erfolgen!\n'
	$sMsg &= '- nderungen am Programm drfen nur durch den Autor vorgenommen werden!\n'
	MsgBox(0, $sTitle & '   -   Programm-Informationen', StringFormat($sMsg, $sVersion, $sDate), 0, $hGui)
EndFunc   ;==>_ProgInfo